// var revs = 0, h, config, status = 0;

var h, maxdisplay= 10000;

Fuel = {
	level: 1000000,
	energy: 100
};

Piston = function() {
	state: 0
};

Drag = {
	obj: null,
	mx: null,
	my: null,
	ox: null,
	oy: null,
	def: null,

	mousedown: function(e, o, def) {
		this.obj = o;
		this.def = def;
		this.mx = e.clientX;
		this.my = e.clientY;
		switch (o.tagName) {
			case 'circle':
				this.ox = parseInt(e.target.getAttribute('cx'));
				this.oy = parseInt(e.target.getAttribute('cy'));
			break;
		}
	},

	mouseup: function(e) {
		this.obj = null;
	},

	mousemove: function(e) {
		if (this.obj == null) return;
		var vx, vy, d = e.clientX - this.mx;
		switch (this.obj.tagName) {
			case 'circle':
				vx = this.ox + d;
				vy = this.oy + d;
				if (vx < this.def.minx) vx = this.def.minx;
				if (vx > this.def.maxx) vx = this.def.maxx;
				if (vy < this.def.miny) vy = this.def.miny;
				if (vy > this.def.maxy) vy = this.def.maxy;
				this.obj.setAttribute('cx', vx);
				this.obj.setAttribute('cy', vy);
			break;
		}
		this.def.callback(vx, vy);
	}
};

Engine = {
	status: 0,
	revs: 0,
	energyrev: 0.001, // Energy x rev
	energyplusrev: 0.003, // Energy x rev
	energyminusrev: 0.001, // Energy x rev
	accelerator: 0.0,
	accelerator_min: 0.0,
	pistons: [new Piston()],

	set_accelerator: function(vx, vy) {
		this.accelerator = (vx - 100.0) / 20;
	}
};

function startstop() {
	if (Engine.status == 0) {
		Engine.status = 1;
		document.getElementById('startstop').setAttribute('fill', 'lime');
	} else {
		Engine.status = 0;
		document.getElementById('startstop').setAttribute('fill', 'red');
	}
	
	if (!h) h = setInterval("refresh()", 20);
}

function refresh() {
	if (Engine.accelerator < 1) Engine.accelerator = 1;
	Engine.accelerator *= Engine.status;

	var e1 = Engine.energyrev * Engine.revs; // Energia persa attuale
	var e2 = Engine.accelerator; // Energia fornita attuale
	var e3 = e2 - e1; // Delta energia
	var e4;

	if (e3 >= 0) {
		e4 = (e3 / Engine.energyplusrev) / 10; 
	} else {
		e4 = (e3 / Engine.energyminusrev) / 10; 
	}

	Engine.revs += e4; // Calcolo nuovo regime
	Fuel.level -= (Engine.energyrev * Engine.revs) / Fuel.energy;

	if (Engine.revs <= 0) {
		Engine.revs = 0;
		clearInterval(h);
		h = null;
	}

	// Display

	var indicatorg = document.getElementById('indicatorg');
	indicatorg.setAttribute('transform', 'rotate('+((Engine.revs * 180 / maxdisplay)-90)+')'); // revs:maxdisplay=ang:180

	var indicator = document.getElementById('indicator');
	var g = 255 - Math.round(255 * Engine.revs / maxdisplay);  // g:255=revs:maxdisplay
	indicator.setAttribute('fill', 'rgb(255,'+g+',0)');
	
	document.getElementById('texter').firstChild.nodeValue = Engine.revs.toFixed(0) + " revs";
	document.getElementById('fuel').firstChild.nodeValue = Fuel.level.toFixed(2);
	document.getElementById('accel').firstChild.nodeValue = ((Engine.accelerator + Engine.accelerator_min) * 100).toFixed(2) + " %";
}

function change(v) {
	if (status = 0) return;
	Engine.revs = maxrevs;
}
